solve( Start, Solution ) :-
    bfs( [ [ Start ] | Z ] - Z, Solution ).


bfs( [ [ Node | Path ] | _ ] - _, [ Node | Path ] ) :-
    goal( Node ).

bfs( [ Path | Paths ] - Z, Solution ) :-
    extend( Path, NewPaths ),
    conc( NewPaths, Z1, Z ),
    Paths \== Z1,
    bfs( Paths - Z1, Solution ).


extend( [ Node | Path ], NewPaths ) :-
    bagof( [ NewNode, Node | Path ],
           ( s(Node,NewNode), not(member(NewNode,[Node|Path])) ),
           NewPaths
    ),
    !.

extend( Path, [] ).
